80788137c670b2b7e7740c99803f03edd9803a3f
[openwrt/staging/mkresin.git] / scripts / config / lxdialog / check-lxdialog.sh
1 #!/bin/sh
2 # Check ncurses compatibility
3
4 # What library to link
5 ldflags()
6 {
7 for ext in so a dll.a dylib ; do
8 for lib in ncursesw ncurses curses ; do
9 $cc -print-file-name=lib${lib}.${ext} | grep -q /
10 if [ $? -eq 0 ]; then
11 echo "-l${lib}"
12 exit
13 fi
14 done
15 done
16 exit 1
17 }
18
19 # Where is ncurses.h?
20 ccflags()
21 {
22 if [ -f /usr/include/ncursesw/curses.h ]; then
23 echo '-I/usr/include/ncursesw -DCURSES_LOC="<ncursesw/curses.h>"'
24 echo ' -DNCURSES_WIDECHAR=1'
25 elif [ -f /usr/include/ncurses/ncurses.h ]; then
26 echo '-I/usr/include/ncurses -DCURSES_LOC="<ncurses.h>"'
27 elif [ -f /usr/include/ncurses/curses.h ]; then
28 echo '-I/usr/include/ncurses -DCURSES_LOC="<ncurses/curses.h>"'
29 elif [ -f /usr/include/ncurses.h ]; then
30 echo '-DCURSES_LOC="<ncurses.h>"'
31 else
32 echo '-DCURSES_LOC="<curses.h>"'
33 fi
34 }
35
36 # Temp file, try to clean up after us
37 tmp=.lxdialog.tmp
38 trap "rm -f $tmp" 0 1 2 3 15
39
40 # Check if we can link to ncurses
41 check() {
42 $cc -x c - -o $tmp 2>/dev/null <<'EOF'
43 #include CURSES_LOC
44 main() {}
45 EOF
46 if [ $? != 0 ]; then
47 echo " *** Unable to find the ncurses libraries or the" 1>&2
48 echo " *** required header files." 1>&2
49 echo " *** 'make menuconfig' requires the ncurses libraries." 1>&2
50 echo " *** " 1>&2
51 echo " *** Install ncurses (ncurses-devel) and try again." 1>&2
52 echo " *** " 1>&2
53 exit 1
54 fi
55 }
56
57 usage() {
58 printf "Usage: $0 [-check compiler options|-ccflags|-ldflags compiler options]\n"
59 }
60
61 if [ $# -eq 0 ]; then
62 usage
63 exit 1
64 fi
65
66 cc=""
67 case "$1" in
68 "-check")
69 shift
70 cc="$@"
71 check
72 ;;
73 "-ccflags")
74 ccflags
75 ;;
76 "-ldflags")
77 shift
78 cc="$@"
79 ldflags
80 ;;
81 "*")
82 usage
83 exit 1
84 ;;
85 esac